<?php
/**
 * Created by PhpStorm.
 * Script Name: Base.php
 * Create: 2020/9/6 下午9:14
 * Description:
 * Author: fudaoji<fdj@kuryun.cn>
 */

namespace app\admin\controller;

use app\common\controller\BaseCtl;

class Base extends BaseCtl
{
    protected $model;
    protected $layout = 'layout/base';
    protected $needLogin = true;
    protected $pk = 'id';
    protected $sKey = 'aid';

    /**
     * @var int
     */
    protected $aid;
    protected $adminInfo;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->layout && $this->view->engine->layout($this->layout);
        $this->needLogin && $this->isLogin();
    }

    /**
     * check if login
     * Author: fudaoji<fdj@kuryun.cn>
     */
    protected function isLogin(){
        $this->aid = (int)session($this->sKey);
        $this->adminInfo = model("admin/admin")->getOne($this->aid);
        if (empty($this->adminInfo)) {
            $this->redirect(url('auth/login'));
        }
        $this->assign['admin'] = $this->adminInfo;
    }

    /**
     * 设置一条或者多条数据的状态
     * @Author  fudaoji<fdj@kuryun.cn>
     */
    public function setStatus() {
        $ids = input('ids/a');
        $status = input('status');

        if (empty($ids)) {
            $this->error('请选择要操作的数据');
        }

        $ids = (array) $ids;
        if($status == 'delete'){
            if($this->model->delBatch($ids)){
                $this->success('删除成功');
            }else{
                $this->error('删除失败');
            }
        }else{
            $arr = [];
            $msg = [
                'success' => '操作成功！',
                'error'   => '操作失败！',
            ];
            switch ($status) {
                case 'forbid' :  // 禁用条目
                    $data['status'] = 0;
                    break;
                case 'resume' :  // 启用条目
                    $data['status'] = 1;
                    break;
                case 'hide' :  // 隐藏条目
                    $data['status'] = 2;
                    break;
                case 'show' :  // 显示条目
                    $data['status'] = 1;
                    break;
                case 'recycle' :  // 移动至回收站
                    $data['status'] = 1;
                    break;
                case 'restore' :  // 从回收站还原
                    $data['status'] = 1;
                    break;
                default:
                    $this->error('参数错误');
                    break;
            }
            foreach($ids as $id){
                $data[$this->pk] = $id;
                $arr[] = $data;
            }
            if($this->model->updateBatch($arr)){
                $this->success($msg['success']);
            }else{
                $this->error($msg['error']);
            }
        }
    }
    /**
     * 保存数据
     * @param string $jump_to
     * @param array $data
     * @return mixed
     */
    public function savePost($jump_to = '/undefined', $data=[]){
        $post_data = $data ? $data : input('post.');
        if(empty($post_data[$this->pk])){
            $res = $this->model->addOne($post_data);
        }else {
            $res = $this->model->updateOne($post_data);
        }

        if($res){
            $this->success('数据保存成功', $jump_to);
        }else{
            $this->error('数据保存出错');
        }
    }
}